/**********************************************************************/
/* MieruPC Project: Sample Version 2009-07-14    Arch Lab. Tokyo Tech */
/**********************************************************************/
#include <mierulib.h>

#define SCREEN_WIDTH_  40
#define SCREEN_HEIGHT  14

/**********************************************************************/
static unsigned int next = 1;

unsigned int myrand(void) {
    next = next * 1103515245 + 12345;
    return((unsigned)(next/65536) % 32768);
}

/**********************************************************************/
int main(void)
{
    int i;
    char ch = '?';
    unsigned int x, y, c;
    volatile int *key_p = (volatile int *) MP_MMAP_KEYCODE;

    lcd_ttyopen(1);
    lcd_printf("Please press the key from '1' to '9'.");

    for(i=0; i<1500; i++) {
        int keycode = *key_p & 0xff;
        
        x = myrand() % SCREEN_WIDTH_;
        y = (myrand() % SCREEN_HEIGHT) + 1;
        c = myrand() % 0xff;

        if(keycode!=0){
            if(keycode==0x61 || keycode==0x31) ch = '1';
            if(keycode==0x62 || keycode==0x32) ch = '2';
            if(keycode==0x63 || keycode==0x33) ch = '3';
            if(keycode==0x64 || keycode==0x34) ch = '4';
            if(keycode==0x65 || keycode==0x35) ch = '5';
            if(keycode==0x66 || keycode==0x36) ch = '6';
            if(keycode==0x67 || keycode==0x37) ch = '7';
            if(keycode==0x68 || keycode==0x38) ch = '8';
            if(keycode==0x69 || keycode==0x39) ch = '9';
        }

        lcd_setcolor(c);
        lcd_locate(x, y);
        lcd_printf("%c", ch);
    }

    return 0;
}

/**********************************************************************/
