/**********************************************************************/
/* MieruPC Project: Sample Version 2009-07-14    Arch Lab. Tokyo Tech */
/**********************************************************************/
#include <mierulib.h>

#define HZ 100000
/**********************************************************************/
int main(void)
{
    char bignum[10][61] = {
        " 0000 00000000  0000  0000  0000  0000  0000  00000000 0000 ",
        " 111   111    11    11    11    11    11    11    11    11  ",
        " 2222 22222222  2222  22   222  222  222  222   222222222222",
        " 3333 33333333  33    33  333   333     3333  33333333 3333 ",
        "   44   444  4444 44444 44 44 44 44 444444444444   44    44 ",
        "55555555555555    55    55555 555555    55    5555555555555 ",
        " 6666 66666 66    66    66666 66666666  6666  66666666 6666 ",
        "777777777777    77   777  777  777   777   777   777   777  ",
        " 8888 88888888  8888  8888888888888888  8888  88888888 8888 ",
        " 9999 99999999  9999  99999999 99999    99    99 99999 9999 "};
    char smallnum[10][16] = {
        "0000 00 00 0000",
        "11  1  1  1  1 ",
        "222  22222  222",
        "333  3333  3333",
        "4 44 4444  4  4",
        "5555  555  5555",
        "6666  6666 6666",
        "7777 7  7 7  7 ",
        "8888 88888 8888",
        "9999 9999  9999"};
    char buf[7];
    int numlast[6] = {-1, -1, -1, -1, -1, -1};
    int numnow[6];
    int numkind[6] = {3, 10, 6, 10, 6, 10};
    int i, j, scroll;
    unsigned int timebuf, hour, min, sec, usec;
    
    lcd_ttyopen(1);
    buf[6] = '\0';

    lcd_locate(17, 14);
    lcd_printf("Press any key to quit.");
    
    while (1) {
        timebuf = *(unsigned int *) 0x10c;
        hour = (timebuf / HZ / 3600) % 24;
        min = (timebuf / HZ / 60) % 60;
        sec = (timebuf / HZ) % 60;
        usec = (timebuf % HZ) * (1000000 / HZ);
        numnow[0] = (hour / 10) * 12;
        numnow[1] = (hour % 10) * 12;
        numnow[2] = (min  / 10) * 12;
        numnow[3] = (min  % 10) * 12;
        numnow[4] = (sec  / 10) * 6;
        numnow[5] = (sec  % 10) * 6;
        numkind[1] = (hour == 23) ? 4 : 10;
        scroll = (usec > 700000) ? (usec - 700000) / 25000 : -1;
        if (scroll > 0)
            for (i = 5; i >= 0; i--) {
                numnow[i] += scroll / (1 + (i >= 4));
                if (numnow[i] * (1 + (i >= 4)) < (numkind[i] - 1) * 12)
                    break;
            }
        for (i = 0; i < 4; i++) {
            if (numnow[i] == numlast[i])
                continue;
            for (j = 0; j < 10; j++) {
                lcd_locate(1 + i * 8, 2 + j);
                if ((numnow[i] + j) % 12 < 10) {
                    memcpy(buf, &bignum[((numnow[i] + j) / 12) % numkind[i]]
                           [((numnow[i] + j) % 12) * 6], 6);
                    lcd_printf(buf);
                } else {
                    lcd_printf("      ");
                }
            }
            numlast[i] = numnow[i];
        }
        for (i = 4; i < 6; i++) {
            if (numnow[i] == numlast[i])
                continue;
            for (j = 0; j < 5; j++) {
                lcd_locate(16 + i * 4, 7 + j);
                if ((numnow[i] + j) % 6 < 5) {
                    memcpy(buf, &smallnum[((numnow[i] + j) / 6) % numkind[i]]
                           [((numnow[i] + j) % 6) * 3], 3);
                    buf[3] = '\0';
                    lcd_printf(buf);
                } else {
                    lcd_printf("   ");
                }
            }
            numlast[i] = numnow[i];
        }

        {
            volatile int *key_p = (volatile int *) MP_MMAP_KEYCODE;
            if(*key_p!=0) exit(0);
        }
    }
    return 0;
}
/**********************************************************************/
