/**********************************************************************/
/* MieruPC Project:                          Fujieda Naoki TOKYO TECH */
/* itcfunc.h Version 2009-07-14                                       */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <termios.h>
#include <time.h>
#include <string.h>

/**********************************************************************/
#define MP_MMAP_KEYCODE 0x0100
#define MP_MMAP_LCD     0x0104
#define MP_MMAP_BUZZER  0x0108
#define MP_MMAP_TIMER   0x010c
#define MP_MMAP_GPIO_0  0x01f0
#define MP_MMAP_GPIO_4  0x01f4
#define MP_MMAP_GPIO_8  0x01f8
#define MP_MMAP_GPIO_C  0x01fc

/**********************************************************************/
#define COL_BLACK       0x00
#define COL_DARKRED     0x80
#define COL_DARKGREEN   0x10
#define COL_DARKBLUE    0x02
#define COL_DARKCYAN    0x12
#define COL_DARKMAGENTA 0x82
#define COL_DARKYELLOW  0x90
#define COL_GRAY        0xb6
#define COL_DARKGRAY    0x6d
#define COL_RED         0xe0
#define COL_GREEN       0x1c
#define COL_BLUE        0x03
#define COL_CYAN        0x1f
#define COL_MAGENTA     0xe3
#define COL_YELLOW      0xfc
#define COL_WHITE       0xff

/**********************************************************************/
void mpc_waitkey();

/**********************************************************************/
int lcd_ttyopen(int);
void lcd_ttyclose();
void lcd_setcolor(int);
void lcd_setshowpage(int);
void lcd_setdrawpage(int);
void lcd_copypage(int, int);
void lcd_cls();
void lcd_setreverse(int);
void lcd_settransparent(int);
void lcd_locate(int, int);
int lcd_printf(char *, ...);
void lcd_nextline();
/**********************************************************************/
